--- old/usr/src/cmd/dd/dd.c	Fri Apr 20 10:14:27 2012
+++ new/usr/src/cmd/dd/dd.c	Fri Apr 20 10:14:27 2012
@@ -23,6 +23,7 @@
 /*
  * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2012, Josef 'Jeff' Sipek <jeffpc@31bits.net>. All rights reserved.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -1642,7 +1643,8 @@
 /* Arg:		big - maximum valid input number			*/
 /* Global arg:	string - pointer to command arg				*/
 /*									*/
-/* Valid forms:	123 | 123k | 123w | 123b | 123*123 | 123x123		*/
+/* Valid forms:	123 | 123k | 123M | 123G | 123T | 123P | 123E | 123Z |	*/
+/*              123w | 123b | 123*123 | 123x123				*/
 /*		plus combinations such as 2b*3kw*4w			*/
 /*									*/
 /* Return:	converted number					*/
@@ -1668,6 +1670,30 @@
 		switch (*cs++)
 		{
 
+		case 'Z':
+			n *= 1024;
+			/* FALLTHROUGH */
+
+		case 'E':
+			n *= 1024;
+			/* FALLTHROUGH */
+
+		case 'P':
+			n *= 1024;
+			/* FALLTHROUGH */
+
+		case 'T':
+			n *= 1024;
+			/* FALLTHROUGH */
+
+		case 'G':
+			n *= 1024;
+			/* FALLTHROUGH */
+
+		case 'M':
+			n *= 1024;
+			/* FALLTHROUGH */
+
 		case 'k':
 			n *= 1024;
 			continue;
--- old/usr/src/man/man1m/dd.1m	Fri Apr 20 10:14:27 2012
+++ new/usr/src/man/man1m/dd.1m	Fri Apr 20 10:14:27 2012
@@ -403,12 +403,48 @@
 .RS +4
 .TP
 3.
+a positive decimal number followed by \fBM\fR, specifying multiplication by
+1024*1024
+.RE
+.RS +4
+.TP
+4.
+a positive decimal number followed by \fBG\fR, specifying multiplication by
+1024*1024*1024
+.RE
+.RS +4
+.TP
+5.
+a positive decimal number followed by \fBT\fR, specifying multiplication by
+1024*1024*1024*1024
+.RE
+.RS +4
+.TP
+6.
+a positive decimal number followed by \fBP\fR, specifying multiplication by
+1024*1024*1024*1024*1024
+.RE
+.RS +4
+.TP
+7.
+a positive decimal number followed by \fBE\fR, specifying multiplication by
+1024*1024*1024*1024*1024*1024
+.RE
+.RS +4
+.TP
+8.
+a positive decimal number followed by \fBZ\fR, specifying multiplication by
+1024*1024*1024*1024*1024*1024*1024
+.RE
+.RS +4
+.TP
+9.
 a positive decimal number followed by \fBb\fR, specifying multiplication by
 512
 .RE
 .RS +4
 .TP
-4.
+10.
 two or more positive decimal numbers (with or without \fBk\fR or \fBb\fR)
 separated by \fBx\fR, specifying the product of the indicated values.
 .RE
